2010-01-01  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (proc): a bug related to initialization of the skeleton was fixed.

	* tculog.c (tculogadbaddint, tculogadbadddouble): efficiency of zero was improved.

	* tcrmgr.c (runput, procput): addint and adddouble were added.

	- Release: 1.1.40

2009-12-07  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttservstart): error handler for the accept call was added.

	* ttserver.c (proc): the system connection limit is now reset.

	- Release: 1.1.39

2009-11-05  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_mc_append, do_mc_prepend): new functions.

	- Release: 1.1.38

2009-10-20  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_stat): "fatal" attribute was added.

	* ttutil.c (ttwaitsock): new function.

	* ttutil.c (ttopensock, ttsocksend, ttsockgetc): "errno" is now copied just in case.

	* tcrdb.c (tcrdbparasearchworker): a bug of race condition was fixed.

	- Release: 1.1.37

2009-10-06  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_strstr): new function.

	* ttserver.c (main, proc): "-mul" option was added.

	- Release: 1.1.36

2009-09-18  Mikio Hirabayashi  <hirarin@gmail.com>

	* tculog.c (tculogadbputshl, tculogadbputshlproc): new functions.

	* scrext.c (iterrec): a bug related to handling the return value was fixed.

	* ttserver.c (do_http_post): "tcadbmisc" is now supported.

	* ttserver.c (do_stat, do_mc_stats): counts of command execution are now output.

	* tcrdb.c (tcrdbparasearch, tcrdbparasearchworker): new functions.

	- Release: 1.1.35

2009-08-04  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbput, tcrdbout, tcrdbget): reconnect mechanism was enhanced.

	* tcrdb.c (tcrdbreconnect): delay mecahism was added.

	* tculog.c (tculrdnew): a bug related to timestamp detection was fixed.

	* tcrmgr.c (runimporttsv, procimporttsv): "-sep" option was added.

	* ttserver.c (do_log): a bug of buffer overrun was fixed.

	- Release: 1.1.34

2009-07-18  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_bit): new function.

	* tcrdb.c (tcrdbqryhint, tcrdbmetasearch): new functions.

	- Release: 1.1.33

2009-07-15  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_mget, do_fwmkeys, do_misc): alignment violations were cleared.

	* tcrmttest.c (runtypical, proctypical, threadtypical): new functions.

	- Release: 1.1.32

2009-07-09  Mikio Hirabayashi  <hirarin@gmail.com>

	* tculog.c (tculogwrite, tculrdread): the master ID is now recorded.

	* ttserver.c (main): the default value of the "-ulim" option was modified.

	* ttserver.c (proc): update logging and replicaion are now forbidden without the SID.

	* ttserver.c (do_repl): the NOP command is now throwed while circular replication.

	- Release: 1.1.31

2009-07-05  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (scrextkill): new function.

	* scrext.c (serv_lock, serv_unlock): lock mechanism was modified with TCMDB.

	- Release: 1.1.30

2009-05-28  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_http_options): new function.

	* tcrtest.c (proctable): a test of full-text search was added.

	- Release: 1.1.29

2009-05-20  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_task): a potential bug of memory leak was fixed.

	* tcrdb.c (tcrdbnew): a bug related to initialization was fixed.

	* scrext.c (serv_fwmkeys, serv_regex): new functions.

	- Release: 1.1.28

2009-05-11  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrtest.c (runtable, proctable): "-exp" option was added.

	* ttskelnull.c: new file.

	* tokyotyrant.idl: new file.

	- Release: 1.1.27

2009-05-09  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttservsettermhandler): new function.

	* ttserver.c (do_term): new function.

	- Release: 1.1.26

2009-05-06  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttcmdidtostr): new function.

	* tculog.c (tcreplopen): a bug of data size of the server ID was fixed.

	* tcrdb.c (tcrdbsetmst, tcrdbsetmst2): the timestamp argument was added.

	* tcrmgr.c (procrepl): command names are now printed.

	* ttulmgr.c (procexport): command names are now printed.

	- Release: 1.1.25

2009-04-25  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttbreakservexpr): new function.

	* tcrdb.c (tcrdbopen2, tcrdbsetmst2, tcrdbtune): new functions.

	* tcrdb.c (tcrdbsetecode, tcrdblockmethod, tcrdbunlockmethod): new functions.

	* ttserver.c (proc): dynamic linking for the skeleton database was added.

	* ttskelmock.c, ttskelproxy.c: new files.

	- Release: 1.1.24

2009-04-07  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_eval, serv_split): new functions.

	* ttserver.c (do_repl): efficiency on dual-master replication was improved.

	* ttserver.c (do_optimize): new function.

	* ttserver.c (do_log): message format was modified.

	* tcrdb.c (tcrdboptimize): new function.

	* tcrdb.c (tcrdbvanish, tcrdbcopy, tcrdbrestore): each magic number was drifted.

	* tcrdb.c (tcrdbrestore, tcrdbsetmst): an argument for options was added.

	* tculog.c (tculogadbredo): the flag of consistency checking was separated.

	- Release: 1.1.23

2009-04-06  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_mapreduce): the parameter for the target keys became an option.

	- Release: 1.1.22

2009-04-06  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_mapreduce): the parameter for the session ID was abolished.

	- Release: 1.1.21

2009-04-01  Mikio Hirabayashi  <hirarin@gmail.com>

	* configure.in: a bug related to support for traditional shells was fixed.

	* scrext.c (serv_stashputkeep, serv_stashputcat): new functions.

	* scrext.c (serv_mapreduce, serv_mapreducemapemit): new functions.

	* ttserver.c (do_put, do_out, do_get): parameter validation was enhanced.

	- Release: 1.1.20

2009-03-14  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbqrysearchget): the option for no update log was added.

	* tcrdb.c (tcrdbqrysearchcount): new function.

	* tculog.c (tcreplread): timeout mechanism was added.

	* ttserver.c (do_repl): performance was improved.

	- Release: 1.1.19

2009-03-14  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttservctl: configuration was modified and update log is now disabled by default.

	* ttutil.c (ttopensock, ttacceptsock): performance was improved.

	* scrext.c (scrextnew): a parameter for the logger was added.

	- Release: 1.1.18

2009-02-19  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (tthttpfetch): timeout mechanism was added.

	* ttserver.c (do_mc_delete): mismatch of the error message was resolved.

	* ttserver.c (do_mc_incr, do_mc_decr): behavior became as with the original memcached.

	* tcrdb.c (tcrdbqrysetlimit): new function instead of "tcrdbqrysetmax".

	- Release: 1.1.17

2009-02-16  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.h: the macro "RDBITOPT" was added.

	* mycond.h, mycond.c, ttutil.c: Solaris portability was added thanks to tamtam.

	- Release: 1.1.16

2009-02-13  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttsockgets2): new function.

	* ttserver (do_task): the size limit of each query was cleared.

	* tcrdb.c (tcrdbqrysearchget): "column" expression was changed to "get".

	- Release: 1.1.15

2009-02-05  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttservstart, ttservaddtimedhandler): multiple tasks are now supported.

	* ttutil.c (ttsockrecv, ttsockgetint32, ttsockgetint64): performance was improved.

	* ttserver.c (do_extpc): new function.

	- Release: 1.1.14

2009-02-04  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbqrysearchout): a bug related to the protocol format was fixed.

	* tcrdb.c (tcrdbqrysearchget): new function.

	- Release: 1.1.13

2009-01-03  Mikio Hirabayashi  <hirarin@gmail.com>

	* myconf.c (nan): xBSDs are now supported.

	* ttserver (proc): parameter checking and warning were added.

	* tcrmgr.c (runmisc, procmisc): table database is now supported.

	* tcrdb.c (tcrdbtblput, tcrdbtblout, tcrdbtblget): new functions.

	* tcrdb.c (tcrdbtblsetindex, tcrdbtblgenuid, tcrdbqrysearch): new functions.

	- Release: 1.1.12

2008-12-08  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbmisc): the return value of the "getlist" function was modified.

	* scrext.c (serv_misc): new function.

	- Release: 1.1.11

2008-12-08  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (tcsocksetlife): new function.

	* scrext.c (scrextnew): "_thnum" parameter was added.

	* scrext.c (serv_foreach, serv_stashvanish, serv_stashforeach): new functions.

	* ttserver.c (do_misc): new function.

	* tculog.c (tculogadbmisc): new function.

	- Release: 1.1.10

2008-12-02  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbputshl): new function instead of "tcrdbputrtt".

	* scrext.c (serv_isect, serv_union): new functions.

	- Release: 1.1.9

2008-10-30  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_lock, serv_unlock): new functions.

	* usherette.lua: new file.

	- Release: 1.1.8

2008-10-20  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (getcmdmask): new function.

	- Release: 1.1.7

2008-10-14  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.h (ttpackdouble, ttunpackdouble): bugs of endian normalization were fixed.

	- Release: 1.1.6

2008-10-07  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_codec, serv_hash, serv_sleep, serv_stat, serv_glob): new functions.

	- Release: 1.1.5

2008-09-28  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttacceptsock, ttgethostaddr): a bug related to byte order was fixed.

	- Release: 1.1.4

2008-09-23  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttdaemonize, ttgetloadavg): new functions.

	* tcrmgr.c (runimporttsv, procimporttsv): new functions.

	* scrext.c (serv_time): new function.

	* ttserver.c (do_stat): the byte order of the server is now sent.

	* ttserver.c (do_http_put): option to switch functions to be called was added.

	* ttserver.c (do_http_post): modified to call a function of the language extension.

	* myconf.c (_tt_epoll_ctl): a potential bug related to misuse of kqueue was fixed.

	- Release: 1.1.3

2008-09-22  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_log): new function.

	- Release: 1.1.2

2008-09-20  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.c (serv_stashput, serv_stashout, serv_stashget): new functions.

	- Release: 1.1.1

2008-09-10  Mikio Hirabayashi  <hirarin@gmail.com>

	* scrext.h, scrext.c: new file.

	* tculog.c (tculogadbaddint, tculogadbadddouble): new functions.

	* ttserver.c (do_ext): new function.

	* tcrdb.c (tcrdbext, tcrdbext2): new functions.

	- Release: 1.1.0

2008-09-05  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttpackdouble, ttunpackdouble): new functions.

	* tcrdb.c (tcrdbaddint, tcrdbadddouble): new functions.

	- Release: 1.0.1

2008-07-29  Mikio Hirabayashi  <hirarin@gmail.com>

	* myconf.c (_tt_epoll_create, _tt_epoll_ctl, _tt_epoll_wait): new functions.

	- Release: 1.0.0

2008-07-14  Mikio Hirabayashi  <hirarin@gmail.com>

	* tculog.c (tculogrmtxidx): a bug related to type cast was fixed.

	* ttserver.c (recmtxidx): a bug related to type cast was fixed.

	* ttserver.c (do_putrtt): new function.

	* tcrdb.c (tcrdbputrtt, tcrdbputrtt2): new functions.

	- Release: 0.9.19

2008-07-10  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_fwmkeys): a bug related to the "max" parameter was fixed.

	- Release: 0.9.18

2008-06-26  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbputnr, tcrdbputnr2): new functions.

	* ttserver.c (do_putnr): new functions.

	- Release: 0.9.17

2008-06-17  Mikio Hirabayashi  <hirarin@gmail.com>

	* tculog.c (tculogbegin): hash locking is now supported.

	- Release: 0.9.16

2008-06-14  Mikio Hirabayashi  <hirarin@gmail.com>

	* tculog.c (tculogsetaio): new function.

	* tculog.c (tculogwrite, tculrdread): the system call "aio_write" is now supported.

	- Release: 0.9.15

2008-05-24  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c, tculog.c, ttserver.c, tcrdb.c: "free" was replaced by "tcfree".

	* ttutil.c (ttsockpfsiz): new function.

	* ttutil.c (tchttpfetch): new function.

	* ttutil.c (ttservdeqtasks): noreply tasks is now supported.

	* ttserver.c (DEFTHNUM): the default number of threads was increased.

	* ttserver.c (do_mc_set, do_mc_add, do_mc_replace, do_mc_delete): "noreply" was added.

	- Release: 0.9.14

2008-03-13  Mikio Hirabayashi  <hirarin@gmail.com>

	* myconf.h: code cleanup.

	- Release: 0.9.13

2008-03-13  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (main): "-ln" option was abolished.

	* ttutil.c (ttacceptsock): keep-alive option was added.

	* ttulmgr.c: new file.

	* ttservctl (start): "ulimit -n" is now used.

	- Release: 0.9.12

2008-03-12  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttservdeqtasks): a bug related to signal handling was fixed.

	- Release: 0.9.11

2008-03-12  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttopenservsock, ttacceptsock): SO_LINGER option was removed.

	* ttserver.c (main, do_log): logging options were added.

	* ttserver.c (do_stat): file descriptor was to be output.

	* ttrtest.c (runwrite, procwrite, runread, procread): "-cnum" option was added.

	- Release: 0.9.10

2008-03-06  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (proc): signal handler options were added.

	- Release: 0.9.9

2008-02-27  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttservstart, ttservdeqtasks): EPOLLONESHOT is now used.

	* tcrtest.c (runwrite, procwrite): "-rnd" option was added.

	- Release: 0.9.8

2008-02-18  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttutil.c (ttopensockunix, ttopenservsockunix): new functions.

	* ttutil.c (ttservstart): unix domain socket is now suppored.

	* tcrdb.c (tcrdbopen): unix domain socket is now suppored.

	* tcrdb.c (tcrdbfwmkeys, tcrdbfwmkeys2): new functions.

	- Release: 0.9.7

2008-02-08  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_timed, do_repl): new functions.

	* ttservctl: new file.

	- Release: 0.9.6

2008-02-02  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbiterinit, tcrdbiternext): new functions.

	* tcrdb.c (tcrdbrestore): new function.

	- Release: 0.9.5

2008-01-30  Mikio Hirabayashi  <hirarin@gmail.com>

	* tcrdb.c (tcrdbsync, tcrdbcopy): new functions.

	* tcrtest.c (runsync, procsync, runcopy, proccopy): new functions.

	* tculog.c, tcltest.c: new files.

	- Release: 0.9.4

2008-01-25  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_mget): new function.

	* tcrdb.c (tcrdbget3): new function.

	- Release: 0.9.3

2008-01-24  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_vsiz, do_http_head, do_http_post): new functions.

	- Release: 0.9.2

2008-01-24  Mikio Hirabayashi  <hirarin@gmail.com>

	* ttserver.c (do_http_get, do_http_put, do_http_delete): new functions.

	- Release: 0.9.1

2008-01-20  Mikio Hirabayashi  <hirarin@gmail.com>

	- The initial version.

	- Release: 0.9.0

